unit StringConcatUnit;

interface

function PlainStringConcat: Integer;

function UseStringBuilder: Integer;

function UseStringList: Integer;

implementation

uses
  DateUtils, SysUtils, System.Text, Classes;

function PlainStringConcat: Integer;
var
  str: string;
  i, ms: Integer;
  t: tDateTime;
begin
  t := Now;
  str := '';
  for I := 1 to 20000 do
  begin
    str := str + IntToStr (i) + ' - ';
  end;
  ms := trunc (MilliSecondSpan(Now, t));
  writeln (str[100]);
  Result := ms;
end;

function UseStringBuilder: Integer;
var
  st: StringBuilder;
  str: string;
  i, ms: Integer;
  t: tDateTime;
begin
  t := Now;
  st := StringBuilder.Create;
  for I := 1 to 20000 do
  begin
    st.Append (IntToStr (i) + ' - ');
  end;
  str := st.ToString;
  ms := trunc (MilliSecondSpan(Now, t));
  writeln (str[100]);
  Result := ms;
end;

function UseStringList: Integer;
var
  sl: TStringList;
  str: string;
  i, ms: Integer;
  t: tDateTime;
begin
  t := Now;
  sl := TStringList.Create;
  for I := 1 to 20000 do
  begin
    sl.Add (IntToStr (i) + ' - ');
  end;
  str := sl.Text;
  ms := trunc (MilliSecondSpan(Now, t));
  writeln (str[100]);
  Result := ms;
end;

end.
