unit ComponentTestForm;

interface

{$WARN UNIT_PLATFORM OFF}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, System.ComponentModel;

type
  TTestForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ScrollBox1: TScrollBox;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.nfm}

procedure TTestForm.Button1Click(Sender: TObject);
begin
  // it is a System.Component
  ShowMessage ((Sender as TComponent).ToString);

  // it is a VCL TComponent
  ShowMessage ((Sender as TComponent).Owner.ClassName);
end;

procedure TTestForm.Button2Click(Sender: TObject);
begin
  // warning: this won't compile under VCL for WIn32
  (Sender as TComponent).Tag := 'Hello'; // TComponent.Tag, a variant
end;

procedure TTestForm.Button3Click(Sender: TObject);
var
  aClass: TControlClass;
begin
  aClass := TControlClass (FindClass ('TButton'));
  with aClass.Create(self) as TControl do
  begin
    Caption := 'Hello' + IntToStr (self.ComponentCount);
    Left := Random (ScrollBox1.Width);
    Top := Random (ScrollBox1.Height);
    Parent := ScrollBox1;
    Show;
  end;
end;

procedure TTestForm.Button4Click(Sender: TObject);
begin
  if Assigned ((Sender as Component).Container) then
  begin
    // show the number of components in the owner/container
    ShowMessage (IntToStr ((Sender as Component).Container.Components.Count));
    // display the container name/description
    ShowMessage (((Sender as Component).Container as TObject).ToString);
  end;
end;

initialization
  RegisterClass (TButton);

end.
