unit ABWinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  TABWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnMatch: System.Windows.Forms.Button;
    TextLog: System.Windows.Forms.TextBox;
    TextInput: System.Windows.Forms.TextBox;
    btnSplit: System.Windows.Forms.Button;
    btnFind: System.Windows.Forms.Button;
    btnSave: System.Windows.Forms.Button;
    btnRead: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnRegex_Click(sender: System.Object; e: System.EventArgs);
    procedure btnSplit_Click(sender: System.Object; e: System.EventArgs);
    procedure btnFind_Click(sender: System.Object; e: System.EventArgs);
    procedure btnSave_Click(sender: System.Object; e: System.EventArgs);
    procedure btnRead_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TABWinForm))]

implementation

uses
  System.Text.RegularExpressions, System.IO;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TABWinForm.InitializeComponent;
begin
  Self.btnMatch := System.Windows.Forms.Button.Create;
  Self.TextLog := System.Windows.Forms.TextBox.Create;
  Self.TextInput := System.Windows.Forms.TextBox.Create;
  Self.btnSplit := System.Windows.Forms.Button.Create;
  Self.btnFind := System.Windows.Forms.Button.Create;
  Self.btnSave := System.Windows.Forms.Button.Create;
  Self.btnRead := System.Windows.Forms.Button.Create;
  Self.SuspendLayout;
  // 
  // btnMatch
  // 
  Self.btnMatch.Location := System.Drawing.Point.Create(24, 32);
  Self.btnMatch.Name := 'btnMatch';
  Self.btnMatch.TabIndex := 0;
  Self.btnMatch.Text := 'Match';
  Include(Self.btnMatch.Click, Self.btnRegex_Click);
  // 
  // TextLog
  // 
  Self.TextLog.Location := System.Drawing.Point.Create(152, 64);
  Self.TextLog.Multiline := True;
  Self.TextLog.Name := 'TextLog';
  Self.TextLog.Size := System.Drawing.Size.Create(408, 216);
  Self.TextLog.TabIndex := 1;
  Self.TextLog.Text := '';
  // 
  // TextInput
  // 
  Self.TextInput.Location := System.Drawing.Point.Create(152, 32);
  Self.TextInput.Name := 'TextInput';
  Self.TextInput.Size := System.Drawing.Size.Create(272, 20);
  Self.TextInput.TabIndex := 2;
  Self.TextInput.Text := '1234-1234-1234-1234';
  // 
  // btnSplit
  // 
  Self.btnSplit.Location := System.Drawing.Point.Create(24, 64);
  Self.btnSplit.Name := 'btnSplit';
  Self.btnSplit.TabIndex := 3;
  Self.btnSplit.Text := 'Split';
  Include(Self.btnSplit.Click, Self.btnSplit_Click);
  // 
  // btnFind
  // 
  Self.btnFind.Location := System.Drawing.Point.Create(24, 96);
  Self.btnFind.Name := 'btnFind';
  Self.btnFind.TabIndex := 4;
  Self.btnFind.Text := 'Find 3';
  Include(Self.btnFind.Click, Self.btnFind_Click);
  // 
  // btnSave
  // 
  Self.btnSave.Location := System.Drawing.Point.Create(24, 144);
  Self.btnSave.Name := 'btnSave';
  Self.btnSave.TabIndex := 5;
  Self.btnSave.Text := 'Save Log';
  Include(Self.btnSave.Click, Self.btnSave_Click);
  // 
  // btnRead
  // 
  Self.btnRead.Location := System.Drawing.Point.Create(24, 176);
  Self.btnRead.Name := 'btnRead';
  Self.btnRead.TabIndex := 6;
  Self.btnRead.Text := 'Read Log';
  Include(Self.btnRead.Click, Self.btnRead_Click);
  // 
  // TABWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(600, 318);
  Self.Controls.Add(Self.btnRead);
  Self.Controls.Add(Self.btnSave);
  Self.Controls.Add(Self.btnFind);
  Self.Controls.Add(Self.btnSplit);
  Self.Controls.Add(Self.TextInput);
  Self.Controls.Add(Self.TextLog);
  Self.Controls.Add(Self.btnMatch);
  Self.Name := 'TABWinForm';
  Self.Text := 'AssortedBcl';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TABWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TABWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TABWinForm.btnRead_Click(sender: System.Object; e: System.EventArgs);
var
  sr1: StreamReader;
  fs: FileStream;
begin
  fs := FileStream.Create ('temp.txt', FileMode.Open, FileAccess.Read);
  try
    sr1 := StreamReader.Create (fs);
    TextLog.Text := sr1.ReadToEnd;
  finally
    fs.Close;
  end;
end;

procedure TABWinForm.btnSave_Click(sender: System.Object; e: System.EventArgs);
var
  sw1: StreamWriter;
begin
  sw1 := StreamWriter.Create ('temp.txt');
  try
    sw1.WriteLine(TextLog.Text);
  finally
    sw1.Close;
  end;
end;

procedure TABWinForm.btnFind_Click(sender: System.Object; e: System.EventArgs);
var
  regex1: Regex;
  match1: Match;
  multiMatch:  MatchCollection;
begin
  regex1 := RegEx.Create ('3');
  match1 := regex1.Match(TextInput.Text);
  if match1.Success then
    TextLog.AppendText('Found at ' + match1.Index.ToString + sLineBreak)
  else
    TextLog.AppendText('Not Found' + sLineBreak);

  multiMatch := regex1.Matches(TextInput.Text);
  for match1 in multiMatch do
    TextLog.AppendText('Multi-Found at ' + match1.Index.ToString + sLineBreak)
end;

procedure TABWinForm.btnSplit_Click(sender: System.Object; e: System.EventArgs);
var
  regex1: Regex;
  lines: array of string;
  str: string;
begin
  regex1 := RegEx.Create ('-');
  lines := regex1.Split(TextInput.Text);
  for str in lines do
    TextLog.AppendText(str + sLineBreak);
end;

procedure TABWinForm.btnRegex_Click(sender: System.Object; e: System.EventArgs);
var
  regex1: Regex;
begin
  regex1 := RegEx.Create ('^\d{4}-\d{4}-\d{4}-\d{4}$');
  if regex1.IsMatch (TextInput.Text) then
    TextLog.AppendText(TextInput.Text + ': regex match' + sLineBreak)
  else
    TextLog.AppendText(TextInput.Text + ': regex doens''t match' + sLineBreak);
end;

end.
