unit CompContForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
  CompContainForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnContainer: System.Windows.Forms.Button;
    Panel1: System.Windows.Forms.Panel;
    btnParent: System.Windows.Forms.Button;
    txtLog: System.Windows.Forms.TextBox;
    btnColor: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnContain_Click(sender: System.Object; e: System.EventArgs);
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure btnColor_Click(sender: System.Object; e: System.EventArgs);
    procedure btnParent_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(CompContainForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure CompContainForm.InitializeComponent;
begin
  Self.btnContainer := System.Windows.Forms.Button.Create;
  Self.Panel1 := System.Windows.Forms.Panel.Create;
  Self.btnColor := System.Windows.Forms.Button.Create;
  Self.btnParent := System.Windows.Forms.Button.Create;
  Self.txtLog := System.Windows.Forms.TextBox.Create;
  Self.Panel1.SuspendLayout;
  Self.SuspendLayout;
  // 
  // btnContainer
  // 
  Self.btnContainer.Location := System.Drawing.Point.Create(40, 24);
  Self.btnContainer.Name := 'btnContainer';
  Self.btnContainer.Size := System.Drawing.Size.Create(120, 23);
  Self.btnContainer.TabIndex := 0;
  Self.btnContainer.Text := 'Show Container';
  Include(Self.btnContainer.Click, Self.btnContain_Click);
  // 
  // Panel1
  // 
  Self.Panel1.BackColor := System.Drawing.SystemColors.ControlLight;
  Self.Panel1.BorderStyle := System.Windows.Forms.BorderStyle.Fixed3D;
  Self.Panel1.Controls.Add(Self.btnColor);
  Self.Panel1.Controls.Add(Self.btnParent);
  Self.Panel1.Location := System.Drawing.Point.Create(40, 72);
  Self.Panel1.Name := 'Panel1';
  Self.Panel1.Size := System.Drawing.Size.Create(192, 136);
  Self.Panel1.TabIndex := 1;
  // 
  // btnColor
  //
  Self.btnColor.Location := System.Drawing.Point.Create(48, 72);
  Self.btnColor.Name := 'btnColor';
  Self.btnColor.Size := System.Drawing.Size.Create(96, 23);
  Self.btnColor.TabIndex := 1;
  Self.btnColor.Text := 'Reset Color';
  Include(Self.btnColor.Click, Self.btnColor_Click);
  // 
  // btnParent
  // 
  Self.btnParent.Location := System.Drawing.Point.Create(48, 32);
  Self.btnParent.Name := 'btnParent';
  Self.btnParent.Size := System.Drawing.Size.Create(96, 23);
  Self.btnParent.TabIndex := 0;
  Self.btnParent.Text := 'Show Parent';
  Include(Self.btnParent.Click, Self.btnParent_Click);
  // 
  // txtLog
  // 
  Self.txtLog.Location := System.Drawing.Point.Create(264, 24);
  Self.txtLog.Multiline := True;
  Self.txtLog.Name := 'txtLog';
  Self.txtLog.Size := System.Drawing.Size.Create(480, 184);
  Self.txtLog.TabIndex := 2;
  Self.txtLog.Text := '';
  // 
  // CompContainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.BackColor := System.Drawing.SystemColors.Control;
  Self.ClientSize := System.Drawing.Size.Create(760, 230);
  Self.Controls.Add(Self.txtLog);
  Self.Controls.Add(Self.Panel1);
  Self.Controls.Add(Self.btnContainer);
  Self.Name := 'CompContainForm';
  Self.Text := 'CompContain';
  Include(Self.Load, Self.TWinForm_Load);
  Self.Panel1.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure CompContainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor CompContainForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure CompContainForm.btnParent_Click(sender: System.Object; e: System.EventArgs);
var
  ctrl: Control;
begin
  txtLog.AppendText ('btnContainer.Parent: ' +
    btnContainer.Parent.ToString + sLineBreak);
  txtLog.AppendText ('btnParent.Parent: ' +
    btnParent.Parent.ToString + sLineBreak);
  for ctrl in self.Controls do
    txtLog.AppendText ('Form controls: ' +
      ctrl.ToString + sLineBreak);
  for ctrl in Panel1.Controls do
    txtLog.AppendText ('Panel controls: ' +
      ctrl.ToString + sLineBreak);
end;

procedure CompContainForm.btnColor_Click(sender: System.Object; e: System.EventArgs);
begin
  Panel1.BackColor := Color.Empty;
end;

procedure CompContainForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
var
  container1: System.ComponentModel.Container;
begin
  container1 := System.ComponentModel.Container.Create;
  container1.Add (Panel1);
  container1.Add (btnParent);
  container1.Add (self);
end;

procedure CompContainForm.btnContain_Click(sender: System.Object; e: System.EventArgs);
var
  comp: Component;
begin
  if (btnParent.Container <> nil) then
  begin
    txtLog.AppendText ('Container: ' +
      TObject(btnParent.Container).ToString + sLineBreak);
    txtLog.AppendText ('Container components count: ' +
      btnParent.Container.Components.Count.ToString + sLineBreak);
    for Comp in btnParent.Container.Components do
      txtLog.AppendText ('Container components: ' +
        Comp.ToString + sLineBreak);
  end;
  if (btnParent.Site <> nil) then
  begin
    txtLog.AppendText ('Site: ' +
      TObject(btnParent.Site).ToString + sLineBreak);
  end;
end;

end.
