unit WinFormStringB;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Text;

type
  TSBForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnString: System.Windows.Forms.Button;
    btnStringBuilder: System.Windows.Forms.Button;
    ListBox1: System.Windows.Forms.ListBox;
    GroupBox1: System.Windows.Forms.GroupBox;
    rbShort: System.Windows.Forms.RadioButton;
    rbLong: System.Windows.Forms.RadioButton;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnString_Click(sender: System.Object; e: System.EventArgs);
    procedure btnStringBuilder_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TSBForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TSBForm.InitializeComponent;
begin
  Self.btnString := System.Windows.Forms.Button.Create;
  Self.btnStringBuilder := System.Windows.Forms.Button.Create;
  Self.ListBox1 := System.Windows.Forms.ListBox.Create;
  Self.GroupBox1 := System.Windows.Forms.GroupBox.Create;
  Self.rbLong := System.Windows.Forms.RadioButton.Create;
  Self.rbShort := System.Windows.Forms.RadioButton.Create;
  Self.GroupBox1.SuspendLayout;
  Self.SuspendLayout;
  // 
  // btnString
  // 
  Self.btnString.Location := System.Drawing.Point.Create(24, 24);
  Self.btnString.Name := 'btnString';
  Self.btnString.Size := System.Drawing.Size.Create(88, 23);
  Self.btnString.TabIndex := 0;
  Self.btnString.Text := 'String';
  Include(Self.btnString.Click, Self.btnString_Click);
  // 
  // btnStringBuilder
  // 
  Self.btnStringBuilder.Location := System.Drawing.Point.Create(24, 64);
  Self.btnStringBuilder.Name := 'btnStringBuilder';
  Self.btnStringBuilder.Size := System.Drawing.Size.Create(88, 23);
  Self.btnStringBuilder.TabIndex := 1;
  Self.btnStringBuilder.Text := 'StringBuilder';
  Include(Self.btnStringBuilder.Click, Self.btnStringBuilder_Click);
  // 
  // ListBox1
  // 
  Self.ListBox1.Location := System.Drawing.Point.Create(128, 24);
  Self.ListBox1.Name := 'ListBox1';
  Self.ListBox1.Size := System.Drawing.Size.Create(432, 225);
  Self.ListBox1.TabIndex := 2;
  // 
  // GroupBox1
  // 
  Self.GroupBox1.Controls.Add(Self.rbLong);
  Self.GroupBox1.Controls.Add(Self.rbShort);
  Self.GroupBox1.Location := System.Drawing.Point.Create(24, 112);
  Self.GroupBox1.Name := 'GroupBox1';
  Self.GroupBox1.Size := System.Drawing.Size.Create(88, 104);
  Self.GroupBox1.TabIndex := 3;
  Self.GroupBox1.TabStop := False;
  Self.GroupBox1.Text := 'String Size';
  // 
  // rbLong
  // 
  Self.rbLong.Location := System.Drawing.Point.Create(16, 64);
  Self.rbLong.Name := 'rbLong';
  Self.rbLong.Size := System.Drawing.Size.Create(55, 24);
  Self.rbLong.TabIndex := 1;
  Self.rbLong.Text := 'Long';
  // 
  // rbShort
  // 
  Self.rbShort.Checked := True;
  Self.rbShort.Location := System.Drawing.Point.Create(16, 24);
  Self.rbShort.Name := 'rbShort';
  Self.rbShort.Size := System.Drawing.Size.Create(56, 24);
  Self.rbShort.TabIndex := 0;
  Self.rbShort.TabStop := True;
  Self.rbShort.Text := 'Short';
  // 
  // TSBForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(584, 270);
  Self.Controls.Add(Self.ListBox1);
  Self.Controls.Add(Self.btnString);
  Self.Controls.Add(Self.btnStringBuilder);
  Self.Controls.Add(Self.GroupBox1);
  Self.Name := 'TSBForm';
  Self.Text := 'StringBuilderDemo';
  Self.GroupBox1.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TSBForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

const
  maxCount = 1000000;
  strSampleShort = 'This is a sample string';
  strSampleLong = 'This is a slightly longer sample string that should be causing some more trouble when copied over and over so many times in memory, if you use the String class instead of StringBuilder class';

constructor TSBForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TSBForm.btnStringBuilder_Click(sender: System.Object; e: System.EventArgs);
var
  aTime: System.DateTime;
  aTimeSpan: System.TimeSpan;
  i, nPos: Integer;
  strB: StringBuilder;
begin
  aTime := System.DateTime.Now;

  // actual code
  strB := StringBuilder.Create;
  if rbShort.Checked then
    strB.Append (strSampleShort)
  else
    strB.Append (strSampleLong);
  for I := 1 to maxCount do
  begin
    nPos := I mod strB.Length;
    strB.Remove(nPos, 1);
    strB.Insert(nPos, strB [(I*2) mod strB.Length]);
  end;
  ListBox1.Items.Add (strB.ToString);
  // end of actual code

  aTimeSpan := System.DateTime.Now - aTime;
  ListBox1.Items.Add('btnString_Click: ' + TObject(aTimeSpan.TotalMilliseconds).ToString);
end;

procedure TSBForm.btnString_Click(sender: System.Object; e: System.EventArgs);
var
  aTime: System.DateTime;
  aTimeSpan: System.TimeSpan;
  i, nPos: Integer;
  str: string;
begin
  aTime := System.DateTime.Now;

  // actual code
  if rbShort.Checked then
    str := strSampleShort
  else
    str := strSampleLong;

  for I := 1 to maxCount do
  begin
    nPos := I mod str.Length;
    str := str.Remove(nPos, 1);
    str := str.Insert(nPos, str [(I*2) mod str.Length + 1]);
  end;
  ListBox1.Items.Add (str);
  // end of actual code

  aTimeSpan := System.DateTime.Now - aTime;
  ListBox1.Items.Add('btnStringBuilder_Click: ' + TObject(aTimeSpan.TotalMilliseconds).ToString);
end;

end.
