unit Math.Utils;

interface

uses
  System.Data, System.Data.OleDb, System.Runtime.InteropServices;

type
  [ComVisible(True), Guid('9DB66430-5DC4-45E4-AD3C-D2D9375D6D87')]
  ICalc = interface
    function Square(Num: Double): Double;
    function SquareRoot(Num: Double): Double;
    function Cube(Num: Double): Double;
    function CubeRoot(Num: Double): Double;
  end;

  [ClassInterface(ClassInterfaceType.None)]
  [ComVisible(True)]
  Calc = class(&Object, ICalc)
  protected
    function Square(Num: Double): Double;
    function SquareRoot(Num: Double): Double;
    function Cube(Num: Double): Double;
    function CubeRoot(Num: Double): Double;
  end;

implementation

{ Calc }

function Calc.CubeRoot(Num: Double): Double;
begin
  Result := System.Math.Pow(Num, 1/3)
end;

function Calc.Cube(Num: Double): Double;
begin
  Result := System.Math.Pow(Num, 3)
end;

function Calc.SquareRoot(Num: Double): Double;
begin
  Result := System.Math.Sqrt(Num)
end;

function Calc.Square(Num: Double): Double;
begin
  Result := Num * Num
end;

end.
